<?php
/**
 * @copyright (c) Kufer Software GmbH, Loisachstrasse 4, D-84453 Mühldorf
 */

namespace Kufer\KuferTools\Basis\Kursdetails\DetailsReiter\Downloads\DownloadZuWeitereKurse;

abstract class DownloadZuWeitereKurseFormularUseCase extends \Kufer\KuferTools\Basis\UseCase\EinzelKursUseCase
{
  public function __construct($request)
  {
    parent::__construct($request, new DownloadZuWeitereKurseFormularResponse());
  }

  
  
  public function hasAccess($pToolSectionId = null)
  {
    
    
    
    if (!\Kufer\KuferTools\Basis\UseCase\ToolUseCase::hasAccess()) {
      return false;
    }
    
    if (!$this->isRechtAllowed($this->getToolSectionId() . '.0.2')) {
      return false;
    }

    
    $dokument = $this->getDokumentWeb();
    
    $kursnummern = $this->getAllowedKursnummern();
    if (!in_array($dokument->knr, $kursnummern)) {
      return false;
    }

    return true;
  }

  

  public function action()
  {
    $user = $this->getUser();
    
    $dokument = $this->getDokumentWeb();
    $kurse = \DokuUploadUserAPI::getKurs4DownloadUebertragen($this->getToolId(), $user, $dokument->knr, $dokument->bezeichnung);

    return $this->getResponse($dokument, $kurse);
  }

  private function getDokumentWeb()
  {
    static $dokument = null;
    if (is_null($dokument)) {
      $dbwDokumenteWeb = new \DBWorkDokumenteWeb(1, true);

      return $dbwDokumenteWeb->getDokument($this->request->dokumentId);
    }

    return $dokument;
  }

  protected function getResponse($dokument, $kurse)
  {
    $this->response->dokument = $dokument;
    $this->response->kurse = $kurse;

    return $this->response;
  }
}

class DownloadZuWeitereKurseFormularRequest
{
  public $dokumentId;
}

class DownloadZuWeitereKurseFormularResponse extends \Kufer\KuferTools\Basis\UseCase\ToolResponse
{
  public $kurse;
  public $dokument;
}